package org.wso2.registry.web.utils;

import org.wso2.registry.Association;
import org.wso2.registry.Registry;
import org.wso2.registry.exceptions.RegistryException;
import org.wso2.registry.web.UIConstants;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class AssociationUtil {
    public static void addAssociation(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        String resourcePath = request.getParameter("resourcePath");

        try {


            String associationType = request.getParameter("type");
            String associationPaths = request.getParameter("associationPaths");
            Registry registry = CommonUtil.getUserRegistry(request);

            registry.addAssociation(resourcePath, associationPaths, associationType);

            Association[] deps = registry.getAllAssociations(resourcePath);
            List assoList = new ArrayList();
            assoList.addAll(Arrays.asList(deps));

            request.getSession().setAttribute(UIConstants.AJAX_ASSOCIATIONS_LIST, assoList);
            request.getRequestDispatcher(UIConstants.AJAX_ASSOCIATIONS_JSP)
                    .forward(request, response);

        } catch (RegistryException e) {
            request.getSession().setAttribute(UIConstants.ERROR_MESSAGE, e.getMessage());

        }
    }
}
